Name: mtl4
Summary: The Matrix Template Library, Version 4
License: BSD-like
Group: Sciences/Mathematics
Version: 2.r6668.alpha
Release: alt2.M50.1
Url: http://www.osl.iu.edu/research/mtl/mtl4/

Source: http://www.osl.iu.edu/download/research/mtl//mtl4-alpha-2-r6668.tar.gz
Source1: http://www.osl.iu.edu/download/research/mtl//mtl-2.1.2-23.tentative.tar.gz
Source2: http://www.osl.iu.edu/download/research/mtl//mtl_reference.tar.gz

Packager: Eugeny A. Rostovtsev (REAL) <real at altlinux.org>

Requires: %name-tests = %version-%release
Requires: %name-examples = %version-%release
Requires: lib%name-devel-docs = %version-%release

BuildRequires(pre): rpm-build-python
BuildRequires: gcc-c++ gcc-fortran liblapack-devel libatlas-devel doxygen
BuildRequires: boost-devel scons python-devel = %__python_version
BuildPreReq: graphviz /usr/bin/dvips

%description
The Matrix Template Library is a C++ class library for basic linear
algebra. The MTL is designed for high-performance while at the same
time taking advantage of the generic programming paradigm (ala the
STL) to allow much greater flexibility and breadth of
functionality. Many new and advanced programming techniques were used
in the construction of this library.

The MTL is a low level library in the sense that the user must be
conscious of the matrix type being used, and that all computationally
expensive operations are explicit. The MTL is not a C++ Matlab or
Mathematica. Nevertheless, the interface is designed to be simple and easy
to use.

The matrix types provided include compressed sparse row/column,
traditional row- and column-major dense, Morton-order, and block-recursive
matrices. All matrix types share a common and easy to use interface.

The algorithms consist of the traditional basic linear algebra
routines (from the BLAS level-1 to 3) which includes matrix and vector
arithmetic.

%package tests
Summary: Test suite for MTL4
Group: Sciences/Mathematics

%description tests
The Matrix Template Library is a C++ class library for basic linear
algebra. The MTL is designed for high-performance while at the same
time taking advantage of the generic programming paradigm (ala the
STL) to allow much greater flexibility and breadth of
functionality. Many new and advanced programming techniques were used
in the construction of this library.

Thies package contains a test suite for MTL.

%package examples
Summary: Examples using MTL
Group: Sciences/Mathematics

%description examples
The Matrix Template Library is a C++ class library for basic linear
algebra. The MTL is designed for high-performance while at the same
time taking advantage of the generic programming paradigm (ala the
STL) to allow much greater flexibility and breadth of
functionality. Many new and advanced programming techniques were used
in the construction of this library.

This package contains example binaries using MTL.

%package -n lib%name-devel-docs
Summary: Documentation for MTL
Group: Development/Documentation
BuildArch: noarch

%description -n lib%name-devel-docs
The Matrix Template Library is a C++ class library for basic linear
algebra. The MTL is designed for high-performance while at the same
time taking advantage of the generic programming paradigm (ala the
STL) to allow much greater flexibility and breadth of
functionality. Many new and advanced programming techniques were used
in the construction of this library.

This package contains development documentation for MTL.

%package -n lib%name-devel
Summary: Development files for MTL v4
Group: Development/C++
Requires: boost-devel

%description -n lib%name-devel
The Matrix Template Library is a C++ class library for basic linear
algebra. The MTL is designed for high-performance while at the same
time taking advantage of the generic programming paradigm (ala the
STL) to allow much greater flexibility and breadth of
functionality. Many new and advanced programming techniques were used
in the construction of this library.

This package contains development files for MTL v4.

%package -n libmtl2-devel
Summary: Development files for MTL v2
Group: Development/C++
Version: 2.1.2

%description -n libmtl2-devel
The Matrix Template Library is a C++ class library for basic linear
algebra. The MTL is designed for high-performance while at the same
time taking advantage of the generic programming paradigm (ala the
STL) to allow much greater flexibility and breadth of
functionality. Many new and advanced programming techniques were used
in the construction of this library.

This package contains development files for MTL v2.

%package -n libmtl2-devel-doc
Summary: Reference guide for the Matrix Template Library, Version 2
License: BSD-like
Group: Development/Documentation
Version: 2.1.1
BuildArch: noarch
Obsoletes: libmtl2-devel-doc < 2.1.1-%release

%description -n libmtl2-devel-doc
The Matrix Template Library is a C++ class library for basic linear
algebra. The MTL is designed for high-performance while at the same
time taking advantage of the generic programming paradigm (ala the
STL) to allow much greater flexibility and breadth of
functionality. Many new and advanced programming techniques were used
in the construction of this library.

The MTL is a low level library in the sense that the user must be
conscious of the matrix type being used, and that all computationally
expensive operations are explicit. The MTL is not a C++ Matlab or
Mathematica. Nevertheless, the interface is designed to be simple and easy
to use.

The matrix types provided include compressed sparse row/column,
traditional row- and column-major dense, Morton-order, and block-recursive
matrices. All matrix types share a common and easy to use interface.

The algorithms consist of the traditional basic linear algebra
routines (from the BLAS level-1 to 3) which includes matrix and vector
arithmetic.

This package contains reference guide for MTL, Version 2

%prep
%setup
tar -xzf %SOURCE1
tar -xzf %SOURCE2

%build
pushd mtl
%autoreconf
%configure \
	--with-exceptions=yes \
	--with-matlab=no \
	--with-lapack="-llapack -latlas -lblas -lcblas -lf77blas -llapack_atlas"
popd

export BOOST_ROOT=%prefix
scons with-blas=1 opt=2 -u -I %python_sitelibdir \
	add_optflag="%optflags %optflags_shared"

doxygen

%install
pushd mtl
%makeinstall includedir=%buildroot%_includedir/mtl
popd

install -d  %buildroot%_bindir
install -d  %buildroot%_libdir
install -d %buildroot%_docdir/%name/examples
install -d %buildroot%_includedir/boost/numeric

install -m644 libs/numeric/mtl/build/libxerbla.a %buildroot%_libdir
install -m755 libs/numeric/itl/test/*test \
	libs/numeric/mtl/test/*test \
	libs/numeric/mtl/test_with_optimization/*test \
	%buildroot%_bindir

mv libs/numeric/mtl/doc/html %buildroot%_docdir/%name/
pushd libs/numeric/mtl/examples
mv images nesting *.cpp CMakeLists.txt SConscript matrix_market *.hpp \
	%buildroot%_docdir/%name/examples
rm -f *.o
mv empty mtl_empty
mv dot mtl_dot
install -m755 * %buildroot%_bindir
popd

mv boost/numeric/* %buildroot%_includedir/boost/numeric/

# MTL reference, Version 2

pushd mtl_reference
install -d %buildroot%_docdir/libmtl2-devel-doc
install -p -m644 * %buildroot%_docdir/libmtl2-devel-doc
popd

%files 
%doc README license*.txt

%files tests
%_bindir/*test

%files examples
%_bindir/*
%exclude %_bindir/*test

%files -n lib%name-devel-docs
%_docdir/%name

%files -n lib%name-devel
%_libdir/*
%_includedir/boost/numeric/*

%files -n libmtl2-devel
%_includedir/mtl

%files  -n libmtl2-devel-doc
%_docdir/libmtl2-devel-doc

%changelog
* Tue May 19 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 2.r6668.alpha-alt2.M50.1
- Port for Branch 5.0

* Tue May 19 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 2.r6668.alpha-alt3
- Avoided conflicts with empty and graphviz

* Thu May 14 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 2.r6668.alpha-alt2
- Add MTL reference, Version 2

* Sun May 03 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 2.r6668.alpha-alt1
- Initial build for Sisyphus

